import { BaseAPIRequestFactory } from './baseapi';
import { Configuration } from '../configuration';
import { RequestContext, ResponseContext } from '../http/http';
import { SupermodelIoLogisticsExpressPickupRequest } from '../models/SupermodelIoLogisticsExpressPickupRequest';
import { SupermodelIoLogisticsExpressPickupResponse } from '../models/SupermodelIoLogisticsExpressPickupResponse';
import { SupermodelIoLogisticsExpressUpdatePickupRequest } from '../models/SupermodelIoLogisticsExpressUpdatePickupRequest';
import { SupermodelIoLogisticsExpressUpdatePickupResponse } from '../models/SupermodelIoLogisticsExpressUpdatePickupResponse';
export declare class PickupApiRequestFactory extends BaseAPIRequestFactory {
    expApiPickups(supermodelIoLogisticsExpressPickupRequest: SupermodelIoLogisticsExpressPickupRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<RequestContext>;
    expApiPickupsCancel(dispatchConfirmationNumber: string, requestorName: string, reason: string, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<RequestContext>;
    expApiPickupsUpdate(dispatchConfirmationNumber: string, supermodelIoLogisticsExpressUpdatePickupRequest: SupermodelIoLogisticsExpressUpdatePickupRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<RequestContext>;
}
export declare class PickupApiResponseProcessor {
    expApiPickups(response: ResponseContext): Promise<SupermodelIoLogisticsExpressPickupResponse>;
    expApiPickupsCancel(response: ResponseContext): Promise<void>;
    expApiPickupsUpdate(response: ResponseContext): Promise<SupermodelIoLogisticsExpressUpdatePickupResponse>;
}
