import { BaseAPIRequestFactory } from './baseapi';
import { Configuration } from '../configuration';
import { RequestContext, ResponseContext } from '../http/http';
import { SupermodelIoLogisticsExpressTrackingResponse } from '../models/SupermodelIoLogisticsExpressTrackingResponse';
export declare class TrackingApiRequestFactory extends BaseAPIRequestFactory {
    expApiShipmentsTracking(shipmentTrackingNumber: string, trackingView?: 'all-checkpoints' | 'last-checkpoint' | 'shipment-details-only' | 'advance-shipment' | 'bbx-children', levelOfDetail?: 'shipment' | 'piece' | 'all', messageReference?: string, messageReferenceDate?: string, acceptLanguage?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<RequestContext>;
    expApiShipmentsTrackingMulti(shipmentTrackingNumber?: Array<string>, pieceTrackingNumber?: Array<string>, shipmentReference?: string, shipmentReferenceType?: string, shipperAccountNumber?: string, dateRangeFrom?: string, dateRangeTo?: string, trackingView?: 'all-checkpoints' | 'last-checkpoint' | 'shipment-details-only' | 'advance-shipment' | 'bbx-children', levelOfDetail?: 'shipment' | 'piece' | 'all', messageReference?: string, messageReferenceDate?: string, acceptLanguage?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<RequestContext>;
}
export declare class TrackingApiResponseProcessor {
    expApiShipmentsTracking(response: ResponseContext): Promise<SupermodelIoLogisticsExpressTrackingResponse>;
    expApiShipmentsTrackingMulti(response: ResponseContext): Promise<SupermodelIoLogisticsExpressTrackingResponse>;
}
