"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ObjectTrackingApi = exports.ObjectShipmentApi = exports.ObjectRatingApi = exports.ObjectProductApi = exports.ObjectPickupApi = exports.ObjectInvoiceApi = exports.ObjectIdentifierApi = exports.ObjectAddressApi = void 0;
var ObservableAPI_1 = require("./ObservableAPI");
var ObjectAddressApi = (function () {
    function ObjectAddressApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_1.ObservableAddressApi(configuration, requestFactory, responseProcessor);
    }
    ObjectAddressApi.prototype.expApiAddressValidate = function (param, options) {
        return this.api.expApiAddressValidate(param.type, param.countryCode, param.postalCode, param.cityName, param.strictValidation, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectAddressApi;
}());
exports.ObjectAddressApi = ObjectAddressApi;
var ObservableAPI_2 = require("./ObservableAPI");
var ObjectIdentifierApi = (function () {
    function ObjectIdentifierApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_2.ObservableIdentifierApi(configuration, requestFactory, responseProcessor);
    }
    ObjectIdentifierApi.prototype.expApiIdentifiers = function (param, options) {
        return this.api.expApiIdentifiers(param.accountNumber, param.type, param.size, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectIdentifierApi;
}());
exports.ObjectIdentifierApi = ObjectIdentifierApi;
var ObservableAPI_3 = require("./ObservableAPI");
var ObjectInvoiceApi = (function () {
    function ObjectInvoiceApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_3.ObservableInvoiceApi(configuration, requestFactory, responseProcessor);
    }
    ObjectInvoiceApi.prototype.expApiShipmentsInvoiceData = function (param, options) {
        return this.api.expApiShipmentsInvoiceData(param.supermodelIoLogisticsExpressUploadInvoiceDataRequestSID, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectInvoiceApi;
}());
exports.ObjectInvoiceApi = ObjectInvoiceApi;
var ObservableAPI_4 = require("./ObservableAPI");
var ObjectPickupApi = (function () {
    function ObjectPickupApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_4.ObservablePickupApi(configuration, requestFactory, responseProcessor);
    }
    ObjectPickupApi.prototype.expApiPickups = function (param, options) {
        return this.api.expApiPickups(param.supermodelIoLogisticsExpressPickupRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectPickupApi.prototype.expApiPickupsCancel = function (param, options) {
        return this.api.expApiPickupsCancel(param.dispatchConfirmationNumber, param.requestorName, param.reason, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectPickupApi.prototype.expApiPickupsUpdate = function (param, options) {
        return this.api.expApiPickupsUpdate(param.dispatchConfirmationNumber, param.supermodelIoLogisticsExpressUpdatePickupRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectPickupApi;
}());
exports.ObjectPickupApi = ObjectPickupApi;
var ObservableAPI_5 = require("./ObservableAPI");
var ObjectProductApi = (function () {
    function ObjectProductApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_5.ObservableProductApi(configuration, requestFactory, responseProcessor);
    }
    ObjectProductApi.prototype.expApiProducts = function (param, options) {
        return this.api.expApiProducts(param.accountNumber, param.originCountryCode, param.originCityName, param.destinationCountryCode, param.destinationCityName, param.weight, param.length, param.width, param.height, param.plannedShippingDate, param.isCustomsDeclarable, param.unitOfMeasurement, param.originPostalCode, param.destinationPostalCode, param.nextBusinessDay, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectProductApi;
}());
exports.ObjectProductApi = ObjectProductApi;
var ObservableAPI_6 = require("./ObservableAPI");
var ObjectRatingApi = (function () {
    function ObjectRatingApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_6.ObservableRatingApi(configuration, requestFactory, responseProcessor);
    }
    ObjectRatingApi.prototype.expApiLandedCost = function (param, options) {
        return this.api.expApiLandedCost(param.supermodelIoLogisticsExpressLandedCostRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectRatingApi.prototype.expApiRates = function (param, options) {
        return this.api.expApiRates(param.accountNumber, param.originCountryCode, param.originCityName, param.destinationCountryCode, param.destinationCityName, param.weight, param.length, param.width, param.height, param.plannedShippingDate, param.isCustomsDeclarable, param.unitOfMeasurement, param.originPostalCode, param.destinationPostalCode, param.nextBusinessDay, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectRatingApi.prototype.expApiRatesMany = function (param, options) {
        return this.api.expApiRatesMany(param.supermodelIoLogisticsExpressRateRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectRatingApi;
}());
exports.ObjectRatingApi = ObjectRatingApi;
var ObservableAPI_7 = require("./ObservableAPI");
var ObjectShipmentApi = (function () {
    function ObjectShipmentApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_7.ObservableShipmentApi(configuration, requestFactory, responseProcessor);
    }
    ObjectShipmentApi.prototype.expApiShipments = function (param, options) {
        return this.api.expApiShipments(param.supermodelIoLogisticsExpressCreateShipmentRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectShipmentApi.prototype.expApiShipmentsDocumentimage = function (param, options) {
        return this.api.expApiShipmentsDocumentimage(param.shipmentTrackingNumber, param.shipperAccountNumber, param.typeCode, param.pickupYearAndMonth, param.encodingFormat, param.allInOnePDF, param.compressedPackage, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectShipmentApi.prototype.expApiShipmentsEpod = function (param, options) {
        return this.api.expApiShipmentsEpod(param.shipmentTrackingNumber, param.shipperAccountNumber, param.content, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectShipmentApi.prototype.expApiShipmentsImgUpload = function (param, options) {
        return this.api.expApiShipmentsImgUpload(param.shipmentTrackingNumber, param.supermodelIoLogisticsExpressImageUploadRequest, options).toPromise();
    };
    ObjectShipmentApi.prototype.expApiShipmentsInvoiceDataAwb = function (param, options) {
        return this.api.expApiShipmentsInvoiceDataAwb(param.shipmentTrackingNumber, param.supermodelIoLogisticsExpressUploadInvoiceDataRequest, param.messageReference, param.messageReferenceDate, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectShipmentApi;
}());
exports.ObjectShipmentApi = ObjectShipmentApi;
var ObservableAPI_8 = require("./ObservableAPI");
var ObjectTrackingApi = (function () {
    function ObjectTrackingApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_8.ObservableTrackingApi(configuration, requestFactory, responseProcessor);
    }
    ObjectTrackingApi.prototype.expApiShipmentsTracking = function (param, options) {
        return this.api.expApiShipmentsTracking(param.shipmentTrackingNumber, param.trackingView, param.levelOfDetail, param.messageReference, param.messageReferenceDate, param.acceptLanguage, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    ObjectTrackingApi.prototype.expApiShipmentsTrackingMulti = function (param, options) {
        if (param === void 0) { param = {}; }
        return this.api.expApiShipmentsTrackingMulti(param.shipmentTrackingNumber, param.pieceTrackingNumber, param.shipmentReference, param.shipmentReferenceType, param.shipperAccountNumber, param.dateRangeFrom, param.dateRangeTo, param.trackingView, param.levelOfDetail, param.messageReference, param.messageReferenceDate, param.acceptLanguage, param.pluginName, param.pluginVersion, param.shippingSystemPlatformName, param.shippingSystemPlatformVersion, param.webstorePlatformName, param.webstorePlatformVersion, options).toPromise();
    };
    return ObjectTrackingApi;
}());
exports.ObjectTrackingApi = ObjectTrackingApi;
//# sourceMappingURL=ObjectParamAPI.js.map