import { Configuration } from '../configuration';
import { SupermodelIoLogisticsExpressAddressValidateResponse } from '../models/SupermodelIoLogisticsExpressAddressValidateResponse';
import { SupermodelIoLogisticsExpressCreateShipmentRequest } from '../models/SupermodelIoLogisticsExpressCreateShipmentRequest';
import { SupermodelIoLogisticsExpressCreateShipmentResponse } from '../models/SupermodelIoLogisticsExpressCreateShipmentResponse';
import { SupermodelIoLogisticsExpressDocumentImageResponse } from '../models/SupermodelIoLogisticsExpressDocumentImageResponse';
import { SupermodelIoLogisticsExpressEPODResponse } from '../models/SupermodelIoLogisticsExpressEPODResponse';
import { SupermodelIoLogisticsExpressIdentifierResponse } from '../models/SupermodelIoLogisticsExpressIdentifierResponse';
import { SupermodelIoLogisticsExpressImageUploadRequest } from '../models/SupermodelIoLogisticsExpressImageUploadRequest';
import { SupermodelIoLogisticsExpressLandedCostRequest } from '../models/SupermodelIoLogisticsExpressLandedCostRequest';
import { SupermodelIoLogisticsExpressPickupRequest } from '../models/SupermodelIoLogisticsExpressPickupRequest';
import { SupermodelIoLogisticsExpressPickupResponse } from '../models/SupermodelIoLogisticsExpressPickupResponse';
import { SupermodelIoLogisticsExpressProducts } from '../models/SupermodelIoLogisticsExpressProducts';
import { SupermodelIoLogisticsExpressRateRequest } from '../models/SupermodelIoLogisticsExpressRateRequest';
import { SupermodelIoLogisticsExpressRates } from '../models/SupermodelIoLogisticsExpressRates';
import { SupermodelIoLogisticsExpressTrackingResponse } from '../models/SupermodelIoLogisticsExpressTrackingResponse';
import { SupermodelIoLogisticsExpressUpdatePickupRequest } from '../models/SupermodelIoLogisticsExpressUpdatePickupRequest';
import { SupermodelIoLogisticsExpressUpdatePickupResponse } from '../models/SupermodelIoLogisticsExpressUpdatePickupResponse';
import { SupermodelIoLogisticsExpressUploadInvoiceDataRequest } from '../models/SupermodelIoLogisticsExpressUploadInvoiceDataRequest';
import { SupermodelIoLogisticsExpressUploadInvoiceDataRequestSID } from '../models/SupermodelIoLogisticsExpressUploadInvoiceDataRequestSID';
import { SupermodelIoLogisticsExpressUploadInvoiceDataResponse } from '../models/SupermodelIoLogisticsExpressUploadInvoiceDataResponse';
import { AddressApiRequestFactory, AddressApiResponseProcessor } from "../apis/AddressApi";
export declare class PromiseAddressApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: AddressApiRequestFactory, responseProcessor?: AddressApiResponseProcessor);
    expApiAddressValidate(type: 'pickup' | 'delivery', countryCode: string, postalCode?: string, cityName?: string, strictValidation?: boolean, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressAddressValidateResponse>;
}
import { IdentifierApiRequestFactory, IdentifierApiResponseProcessor } from "../apis/IdentifierApi";
export declare class PromiseIdentifierApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: IdentifierApiRequestFactory, responseProcessor?: IdentifierApiResponseProcessor);
    expApiIdentifiers(accountNumber: string, type: 'SID' | 'PID' | 'ASID3' | 'ASID6' | 'ASID12' | 'ASID24' | 'HUID', size: string, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressIdentifierResponse>;
}
import { InvoiceApiRequestFactory, InvoiceApiResponseProcessor } from "../apis/InvoiceApi";
export declare class PromiseInvoiceApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: InvoiceApiRequestFactory, responseProcessor?: InvoiceApiResponseProcessor);
    expApiShipmentsInvoiceData(supermodelIoLogisticsExpressUploadInvoiceDataRequestSID: SupermodelIoLogisticsExpressUploadInvoiceDataRequestSID, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressUploadInvoiceDataResponse>;
}
import { PickupApiRequestFactory, PickupApiResponseProcessor } from "../apis/PickupApi";
export declare class PromisePickupApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: PickupApiRequestFactory, responseProcessor?: PickupApiResponseProcessor);
    expApiPickups(supermodelIoLogisticsExpressPickupRequest: SupermodelIoLogisticsExpressPickupRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressPickupResponse>;
    expApiPickupsCancel(dispatchConfirmationNumber: string, requestorName: string, reason: string, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<void>;
    expApiPickupsUpdate(dispatchConfirmationNumber: string, supermodelIoLogisticsExpressUpdatePickupRequest: SupermodelIoLogisticsExpressUpdatePickupRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressUpdatePickupResponse>;
}
import { ProductApiRequestFactory, ProductApiResponseProcessor } from "../apis/ProductApi";
export declare class PromiseProductApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: ProductApiRequestFactory, responseProcessor?: ProductApiResponseProcessor);
    expApiProducts(accountNumber: string, originCountryCode: string, originCityName: string, destinationCountryCode: string, destinationCityName: string, weight: number, length: number, width: number, height: number, plannedShippingDate: string, isCustomsDeclarable: boolean, unitOfMeasurement: 'metric' | 'imperial', originPostalCode?: string, destinationPostalCode?: string, nextBusinessDay?: boolean, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressProducts>;
}
import { RatingApiRequestFactory, RatingApiResponseProcessor } from "../apis/RatingApi";
export declare class PromiseRatingApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: RatingApiRequestFactory, responseProcessor?: RatingApiResponseProcessor);
    expApiLandedCost(supermodelIoLogisticsExpressLandedCostRequest: SupermodelIoLogisticsExpressLandedCostRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressRates>;
    expApiRates(accountNumber: string, originCountryCode: string, originCityName: string, destinationCountryCode: string, destinationCityName: string, weight: number, length: number, width: number, height: number, plannedShippingDate: string, isCustomsDeclarable: boolean, unitOfMeasurement: 'metric' | 'imperial', originPostalCode?: string, destinationPostalCode?: string, nextBusinessDay?: boolean, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressRates>;
    expApiRatesMany(supermodelIoLogisticsExpressRateRequest: SupermodelIoLogisticsExpressRateRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressRates>;
}
import { ShipmentApiRequestFactory, ShipmentApiResponseProcessor } from "../apis/ShipmentApi";
export declare class PromiseShipmentApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: ShipmentApiRequestFactory, responseProcessor?: ShipmentApiResponseProcessor);
    expApiShipments(supermodelIoLogisticsExpressCreateShipmentRequest: SupermodelIoLogisticsExpressCreateShipmentRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressCreateShipmentResponse>;
    expApiShipmentsDocumentimage(shipmentTrackingNumber: string, shipperAccountNumber: string, typeCode: 'waybill' | 'commercial-invoice' | 'customs-entry', pickupYearAndMonth: string, encodingFormat?: 'pdf' | 'tiff', allInOnePDF?: boolean, compressedPackage?: boolean, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressDocumentImageResponse>;
    expApiShipmentsEpod(shipmentTrackingNumber: string, shipperAccountNumber?: string, content?: 'epod-detail' | 'epod-summary' | 'epod-detail-esig' | 'epod-summary-esig' | 'epod-table', messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressEPODResponse>;
    expApiShipmentsImgUpload(shipmentTrackingNumber: string, supermodelIoLogisticsExpressImageUploadRequest: SupermodelIoLogisticsExpressImageUploadRequest, _options?: Configuration): Promise<void>;
    expApiShipmentsInvoiceDataAwb(shipmentTrackingNumber: string, supermodelIoLogisticsExpressUploadInvoiceDataRequest: SupermodelIoLogisticsExpressUploadInvoiceDataRequest, messageReference?: string, messageReferenceDate?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<void>;
}
import { TrackingApiRequestFactory, TrackingApiResponseProcessor } from "../apis/TrackingApi";
export declare class PromiseTrackingApi {
    private api;
    constructor(configuration: Configuration, requestFactory?: TrackingApiRequestFactory, responseProcessor?: TrackingApiResponseProcessor);
    expApiShipmentsTracking(shipmentTrackingNumber: string, trackingView?: 'all-checkpoints' | 'last-checkpoint' | 'shipment-details-only' | 'advance-shipment' | 'bbx-children', levelOfDetail?: 'shipment' | 'piece' | 'all', messageReference?: string, messageReferenceDate?: string, acceptLanguage?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressTrackingResponse>;
    expApiShipmentsTrackingMulti(shipmentTrackingNumber?: Array<string>, pieceTrackingNumber?: Array<string>, shipmentReference?: string, shipmentReferenceType?: string, shipperAccountNumber?: string, dateRangeFrom?: string, dateRangeTo?: string, trackingView?: 'all-checkpoints' | 'last-checkpoint' | 'shipment-details-only' | 'advance-shipment' | 'bbx-children', levelOfDetail?: 'shipment' | 'piece' | 'all', messageReference?: string, messageReferenceDate?: string, acceptLanguage?: string, pluginName?: string, pluginVersion?: string, shippingSystemPlatformName?: string, shippingSystemPlatformVersion?: string, webstorePlatformName?: string, webstorePlatformVersion?: string, _options?: Configuration): Promise<SupermodelIoLogisticsExpressTrackingResponse>;
}
