"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PromiseTrackingApi = exports.PromiseShipmentApi = exports.PromiseRatingApi = exports.PromiseProductApi = exports.PromisePickupApi = exports.PromiseInvoiceApi = exports.PromiseIdentifierApi = exports.PromiseAddressApi = void 0;
var ObservableAPI_1 = require("./ObservableAPI");
var PromiseAddressApi = (function () {
    function PromiseAddressApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_1.ObservableAddressApi(configuration, requestFactory, responseProcessor);
    }
    PromiseAddressApi.prototype.expApiAddressValidate = function (type, countryCode, postalCode, cityName, strictValidation, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiAddressValidate(type, countryCode, postalCode, cityName, strictValidation, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseAddressApi;
}());
exports.PromiseAddressApi = PromiseAddressApi;
var ObservableAPI_2 = require("./ObservableAPI");
var PromiseIdentifierApi = (function () {
    function PromiseIdentifierApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_2.ObservableIdentifierApi(configuration, requestFactory, responseProcessor);
    }
    PromiseIdentifierApi.prototype.expApiIdentifiers = function (accountNumber, type, size, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiIdentifiers(accountNumber, type, size, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseIdentifierApi;
}());
exports.PromiseIdentifierApi = PromiseIdentifierApi;
var ObservableAPI_3 = require("./ObservableAPI");
var PromiseInvoiceApi = (function () {
    function PromiseInvoiceApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_3.ObservableInvoiceApi(configuration, requestFactory, responseProcessor);
    }
    PromiseInvoiceApi.prototype.expApiShipmentsInvoiceData = function (supermodelIoLogisticsExpressUploadInvoiceDataRequestSID, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsInvoiceData(supermodelIoLogisticsExpressUploadInvoiceDataRequestSID, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseInvoiceApi;
}());
exports.PromiseInvoiceApi = PromiseInvoiceApi;
var ObservableAPI_4 = require("./ObservableAPI");
var PromisePickupApi = (function () {
    function PromisePickupApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_4.ObservablePickupApi(configuration, requestFactory, responseProcessor);
    }
    PromisePickupApi.prototype.expApiPickups = function (supermodelIoLogisticsExpressPickupRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiPickups(supermodelIoLogisticsExpressPickupRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromisePickupApi.prototype.expApiPickupsCancel = function (dispatchConfirmationNumber, requestorName, reason, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiPickupsCancel(dispatchConfirmationNumber, requestorName, reason, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromisePickupApi.prototype.expApiPickupsUpdate = function (dispatchConfirmationNumber, supermodelIoLogisticsExpressUpdatePickupRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiPickupsUpdate(dispatchConfirmationNumber, supermodelIoLogisticsExpressUpdatePickupRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromisePickupApi;
}());
exports.PromisePickupApi = PromisePickupApi;
var ObservableAPI_5 = require("./ObservableAPI");
var PromiseProductApi = (function () {
    function PromiseProductApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_5.ObservableProductApi(configuration, requestFactory, responseProcessor);
    }
    PromiseProductApi.prototype.expApiProducts = function (accountNumber, originCountryCode, originCityName, destinationCountryCode, destinationCityName, weight, length, width, height, plannedShippingDate, isCustomsDeclarable, unitOfMeasurement, originPostalCode, destinationPostalCode, nextBusinessDay, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiProducts(accountNumber, originCountryCode, originCityName, destinationCountryCode, destinationCityName, weight, length, width, height, plannedShippingDate, isCustomsDeclarable, unitOfMeasurement, originPostalCode, destinationPostalCode, nextBusinessDay, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseProductApi;
}());
exports.PromiseProductApi = PromiseProductApi;
var ObservableAPI_6 = require("./ObservableAPI");
var PromiseRatingApi = (function () {
    function PromiseRatingApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_6.ObservableRatingApi(configuration, requestFactory, responseProcessor);
    }
    PromiseRatingApi.prototype.expApiLandedCost = function (supermodelIoLogisticsExpressLandedCostRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiLandedCost(supermodelIoLogisticsExpressLandedCostRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseRatingApi.prototype.expApiRates = function (accountNumber, originCountryCode, originCityName, destinationCountryCode, destinationCityName, weight, length, width, height, plannedShippingDate, isCustomsDeclarable, unitOfMeasurement, originPostalCode, destinationPostalCode, nextBusinessDay, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiRates(accountNumber, originCountryCode, originCityName, destinationCountryCode, destinationCityName, weight, length, width, height, plannedShippingDate, isCustomsDeclarable, unitOfMeasurement, originPostalCode, destinationPostalCode, nextBusinessDay, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseRatingApi.prototype.expApiRatesMany = function (supermodelIoLogisticsExpressRateRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiRatesMany(supermodelIoLogisticsExpressRateRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseRatingApi;
}());
exports.PromiseRatingApi = PromiseRatingApi;
var ObservableAPI_7 = require("./ObservableAPI");
var PromiseShipmentApi = (function () {
    function PromiseShipmentApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_7.ObservableShipmentApi(configuration, requestFactory, responseProcessor);
    }
    PromiseShipmentApi.prototype.expApiShipments = function (supermodelIoLogisticsExpressCreateShipmentRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipments(supermodelIoLogisticsExpressCreateShipmentRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseShipmentApi.prototype.expApiShipmentsDocumentimage = function (shipmentTrackingNumber, shipperAccountNumber, typeCode, pickupYearAndMonth, encodingFormat, allInOnePDF, compressedPackage, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsDocumentimage(shipmentTrackingNumber, shipperAccountNumber, typeCode, pickupYearAndMonth, encodingFormat, allInOnePDF, compressedPackage, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseShipmentApi.prototype.expApiShipmentsEpod = function (shipmentTrackingNumber, shipperAccountNumber, content, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsEpod(shipmentTrackingNumber, shipperAccountNumber, content, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseShipmentApi.prototype.expApiShipmentsImgUpload = function (shipmentTrackingNumber, supermodelIoLogisticsExpressImageUploadRequest, _options) {
        var result = this.api.expApiShipmentsImgUpload(shipmentTrackingNumber, supermodelIoLogisticsExpressImageUploadRequest, _options);
        return result.toPromise();
    };
    PromiseShipmentApi.prototype.expApiShipmentsInvoiceDataAwb = function (shipmentTrackingNumber, supermodelIoLogisticsExpressUploadInvoiceDataRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsInvoiceDataAwb(shipmentTrackingNumber, supermodelIoLogisticsExpressUploadInvoiceDataRequest, messageReference, messageReferenceDate, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseShipmentApi;
}());
exports.PromiseShipmentApi = PromiseShipmentApi;
var ObservableAPI_8 = require("./ObservableAPI");
var PromiseTrackingApi = (function () {
    function PromiseTrackingApi(configuration, requestFactory, responseProcessor) {
        this.api = new ObservableAPI_8.ObservableTrackingApi(configuration, requestFactory, responseProcessor);
    }
    PromiseTrackingApi.prototype.expApiShipmentsTracking = function (shipmentTrackingNumber, trackingView, levelOfDetail, messageReference, messageReferenceDate, acceptLanguage, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsTracking(shipmentTrackingNumber, trackingView, levelOfDetail, messageReference, messageReferenceDate, acceptLanguage, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    PromiseTrackingApi.prototype.expApiShipmentsTrackingMulti = function (shipmentTrackingNumber, pieceTrackingNumber, shipmentReference, shipmentReferenceType, shipperAccountNumber, dateRangeFrom, dateRangeTo, trackingView, levelOfDetail, messageReference, messageReferenceDate, acceptLanguage, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options) {
        var result = this.api.expApiShipmentsTrackingMulti(shipmentTrackingNumber, pieceTrackingNumber, shipmentReference, shipmentReferenceType, shipperAccountNumber, dateRangeFrom, dateRangeTo, trackingView, levelOfDetail, messageReference, messageReferenceDate, acceptLanguage, pluginName, pluginVersion, shippingSystemPlatformName, shippingSystemPlatformVersion, webstorePlatformName, webstorePlatformVersion, _options);
        return result.toPromise();
    };
    return PromiseTrackingApi;
}());
exports.PromiseTrackingApi = PromiseTrackingApi;
//# sourceMappingURL=PromiseAPI.js.map